#
# EDOS testing framework
# Copyright (C) 2006 EDGE-IT
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#

#
# Author: Francois Dechelle <fdechelle@mandriva.com>
#

import os
import threading
import subprocess

# Obsolete
# A priori no longer usefull with subprocess.Popen (but requires Python 2.4)
class CmdThreadOld( threading.Thread):
    def __init__( self, infile):
        threading.Thread.__init__( self)
        self.infile = infile

    def run( self):
        self.result = self.infile.read()

class ShellCommandOld:
    # Old code using popen3: does not work as is, but I leave it here because it may be usefull for Python version < 2.4
    def runOld(self):
        (stdin, stdout, stderr) = os.popen3(args)
        outThread = CmdThread(stdout)
        errThread = CmdThread(stderr)
        outThread.start()
        errThread.start()

        outThread.join()
        errThread.join()

        self.stdout = outThread.result
        self.stderr = errThread.result

        return (self.stdout, self.stderr)
# end obsolete


class ShellCommand:
    def __init__( self):
        self.args = []
        
    def __init__( self, script, ignoreReturnCode = False, shortLog = False):
        self.args = [script]
        self.ignoreReturnCode = ignoreReturnCode
        self.__doShortLog__ = shortLog

    def commandLine( self):
        return ' '.join(self.args)

    def run( self, basedir):
        cmdline = self.commandLine()
        print 'running %s in directory %s' % (cmdline, basedir)
        print self.args
        
        if not os.path.exists( basedir):
            os.makedirs( basedir)

        fd = open(basedir+'/cmdline','w')
        fd.write(cmdline)
        fd.close()
        
        p = subprocess.Popen( cmdline,
                              shell=True,
                              stdin=None,
                              stdout=open(basedir+'/stdout','w'),
                              stderr=open(basedir+'/stderr','w'),
                              close_fds=True,
                              cwd=basedir)

        self.returncode = p.wait()

        if self.__doShortLog__:
            self.shortLog = u'+ '
            self.shortLog += cmdline
            self.shortLog += '\n'
            fd = open(basedir+'/stdout','r')
            self.shortLog += fd.read().decode('utf_8','replace')

        return self.returncode


