#
# EDOS testing framework
# Copyright (C) 2006 EDGE-IT
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#

#
# Author: Francois Dechelle <fdechelle@mandriva.com>
#

import os.path
import sys
import optparse
import ConfigParser
from edostestrunner.test import Test
from edostestrunner.config import Config

def collectOptions():
    parser = optparse.OptionParser()

    parser.add_option('-f', '--file',
                      dest='filename',
                      help='read XML test specification from FILE', metavar='FILE')

#    parser.add_option('-q', '--quiet',
#                      action='store_false',
#                      dest='verbose',
#                      default=True,
#                      help="don't print status messages to stdout")

    parser.add_option('-c', '--config-file',
                      dest='configFile',
                      help='read configuration from FILE', metavar='FILE')

    parser.add_option('-d', '--test-directory',
                      dest='testDirectory',
                      help='run tests in directory DIR', metavar='DIR')

#    parser.add_option('-r', '--reporting',
#                      action='append'
#                      dest='reporting',
#                      help='run tests in directory DIR', metavar='DIR')

#    parser.add_option('-u', '--user',
#                      dest='user',
#                      help='use USER name for tester', metavar='USER')

    (options, args) = parser.parse_args()

    if options.filename is None:
#        usage = "usage: %prog [options]"
        parser.print_help()
        parser.error( "no XML test specification file given")
 
    return options


def main(args):
    options = collectOptions()

    config = Config( options.configFile)

    testReporter = config.getReporter()
    print testReporter

    t = Test( options.filename)

    if not options.testDirectory is None:
        t.run( testReporter, options.testDirectory)
    else:
        t.run( testReporter)

